package ca.uwaterloo.crysp.trainerSS;

import java.util.ArrayList;

public class SensorData {
	long tstamp;
	float x,y,z;
	public SensorData(long _tstamp, float _x, float _y, float _z) {
		tstamp = _tstamp;
		x = _x;
		y = _y;
		z = _z;
	}
	/*returns linear acceleration/angular velocity*/
	public static double procSensorData (ArrayList<SensorData> acc) {
		double rv = 0;
		if (acc.size() < 2)
			return rv;
		long tdiff = acc.get(acc.size()-1).tstamp - acc.get(0).tstamp;
		tdiff /= 1000000;	//convert ns to ms
		float xdisp = 0, ydisp = 0, zdisp = 0;
		for (int i = 0; i < acc.size()-1; i++) {
			xdisp += acc.get(i+1).x - acc.get(i).x;
			ydisp += acc.get(i+1).y - acc.get(i).y;
			zdisp += acc.get(i+1).z - acc.get(i).z;
		}
		xdisp /= tdiff;
		ydisp /= tdiff;
		zdisp /= tdiff;
		
		rv = Math.sqrt(Math.pow(xdisp, 2) + Math.pow(ydisp, 2) + Math.pow(zdisp, 2));
		return rv;
	}
}
